GMSSParameters (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.pqc.crypto.gmss

## Class GMSSParameters

- java.lang.Object
- - org.bouncycastle.pqc.crypto.gmss.GMSSParameters

-     public class GMSSParameters
      extends java.lang.Object

  This class provides a specification for the GMSS parameters that are used by the GMSSKeyPairGenerator and GMSSSignature classes.
  See Also:
    `GMSSKeyPairGenerator`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GMSSParameters(int keySize)`
    `GMSSParameters(int layers, int[] heightOfTrees, int[] winternitzParameter, int[] K)` The constructor for the parameters of the GMSSKeyPairGenerator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int[]` | `getHeightOfTrees()` Returns the array of height (for each layer) of the authentication trees
    `int[]` | `getK()` Returns the parameter K needed for authentication path computation
    `int` | `getNumOfLayers()` Returns the number of levels of the authentication trees.
    `int[]` | `getWinternitzParameter()` Returns the array of WinternitzParameter (for each layer) of the authentication trees

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GMSSParameters

          public GMSSParameters(int layers,
                        int[] heightOfTrees,
                        int[] winternitzParameter,
                        int[] K)
                         throws java.lang.IllegalArgumentException

      The constructor for the parameters of the GMSSKeyPairGenerator.
      Parameters:
        `layers` - the number of authentication tree layers
        `heightOfTrees` - the height of the authentication trees
        `winternitzParameter` - the Winternitz Parameter 'w' of each layer
        `K` - parameter for authpath computation
      Throws:
        `java.lang.IllegalArgumentException`

    - #### GMSSParameters

          public GMSSParameters(int keySize)
                         throws java.lang.IllegalArgumentException

      Throws:
        `java.lang.IllegalArgumentException`

  - ### Method Detail

    - #### getNumOfLayers

          public int getNumOfLayers()

      Returns the number of levels of the authentication trees.
      Returns:
        The number of levels of the authentication trees.

    - #### getHeightOfTrees

          public int[] getHeightOfTrees()

      Returns the array of height (for each layer) of the authentication trees
      Returns:
        The array of height (for each layer) of the authentication trees

    - #### getWinternitzParameter

          public int[] getWinternitzParameter()

      Returns the array of WinternitzParameter (for each layer) of the authentication trees
      Returns:
        The array of WinternitzParameter (for each layer) of the authentication trees

    - #### getK

          public int[] getK()

      Returns the parameter K needed for authentication path computation
      Returns:
        The parameter K needed for authentication path computation